﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;


namespace WindowsApplication1
{
    class Program
    {
        /// <summary>
        /// 应用程序的主入口点。
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            Application.Run(new Form1());
        }
        
        [StructLayout(LayoutKind.Sequential)]
        public struct ReaderDate
        {
	        public byte	Year;			//年
	        public byte	Month;			//月
	        public byte	Day;			//日
	        public byte	Hour;			//时
	        public byte	Minute;			//分
	        public byte	Second;			//秒
        }
        public struct Parameter
        {
            public byte BaudRate;			
            public byte Power;				
            public byte Min_Frequence;		
            public byte Antenna;			
            public byte WorkMode;			
            public byte ReadInterval;		
            public byte OutMode;			
            public byte TriggerMode;	    
            public byte IDPosition;			
            public byte IfTestValidity;		
            public byte OutInterface;	
            public byte NumofCard;			
            public byte Power2;				
            public byte TagType;			
            public byte WiegandWidth;		
            public byte WiegandInterval;	
            public byte ID_Start;			
            public byte Max_Frequence;		
            public byte ReadDuration;		
            public byte StandardTime;		
            public byte EnableBuzzer;
            public byte ReaderAddress;
            public byte HostIP1;			//上位机IP地址1
            public byte HostIP2;			//上位机IP地址2
            public byte HostIP3;			//上位机IP地址3
            public byte HostIP4;			//上位机IP地址4
            public byte HostPort1;			//上位机端口1
            public byte HostPort2;			//上位机端口2
            public byte Reserve29;			
            public byte Reserve30;			
            public byte TX_Mode;			
            public byte Modulation;
        }

#region Controlling command

//连接读写器
        [DllImport("Reader1000DLL.dll")]
        public static extern int ConnectScanner(ref int hScanner, string PortNum, int nBaudRate);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ConnectScanner(ref int hSocket, string nTargetAddress, uint nTargetPort, string nHostAddress, uint nHostPort);
//断开读写器连接
        [DllImport("Reader1000DLL.dll")]
        public static extern int DisconnectScanner(int hScanner);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_DisconnectScanner();
//获得读写器版本号        
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetReaderVersion(int hScanner, ref int hardver, ref int Softver, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetReaderVersion(int hSocket, ref int hardver, ref int Softver);
//选择工作天线        
        [DllImport("Reader1000DLL.dll")]
        public static extern int SetAntenna(int hScanner, int m_antenna_sel, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_SetAntenna(int hSocket, int m_antenna_sel);

//设置读写器继电器状态
        [DllImport("Reader1000DLL.dll")]
        public static extern int SetRelay(int hScanner, int Relay, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_SetRelay(int hSocket, int Relay);

//设定输出功率
        [DllImport("Reader1000DLL.dll")]
        public static extern int SetOutputPower(int hScanner, int nPower1, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_SetOutputPower(int hSocket, int nPower1);

//读取写器工作参数
        [DllImport("Reader1000DLL.dll")]
        public static extern int ReadParam(int hScanner, ref Parameter pParam, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ReadParam(int hSocket, ref Parameter pParam);

//设置读写器工作参数
        [DllImport("Reader1000DLL.dll")]
        public static extern int WriteParam(int hScanner, ref Parameter pParam, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_WriteParam(int hSocket, ref Parameter pParam);

//读取读写器出厂参数
        [DllImport("Reader1000DLL.dll")]
        public static extern int ReadFactoryParameter(int hScanner);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ReadFactoryParameter(int hSocket);

//复位读写器
        [DllImport("Reader1000DLL.dll")]
        public static extern int Reboot(int hScanner, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_Reboot(int hSocket);
//设置时间
        [DllImport("Reader1000DLL.dll")]
        public static extern int SetReaderTime(int hScanner, ReaderDate time, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_SetReaderTime(int hSocket, ReaderDate time);

//获得时间
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetReaderTime(int hScanner, ref ReaderDate time, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetReaderTime(int hSocket, ref ReaderDate time);

//增加名单
        [DllImport("Reader1000DLL.dll")]
        public static extern int AddLableID(int hScanner, int listlen, int datalen, byte[] data);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_AddLableID(int hSocket, int listlen, int datalen, byte[] data);

//删除名单
        [DllImport("Reader1000DLL.dll")]
        public static extern int DelLableID(int hScanner, int listlen, int datalen, byte[] data);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_DelLableID(int hSocket, int listlen, int datalen, byte[] data);

//获得名单
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetLableID(int hScanner, int startaddr, int listlen, ref int relistlen, ref int taglen, byte[] data);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetLableID(int hSocket, int startaddr, int listlen, ref int relistlen, ref int taglen, byte[] data);

//获得记录
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetRecord(int hScanner, ref ReaderDate stime, ref ReaderDate etime, int startaddr, int listlen, ref int relistlen, ref int taglen, byte[] data);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetRecord(int hSocket, ref ReaderDate stime, ref ReaderDate etime, int startaddr, int listlen, ref int relistlen, ref int taglen, byte[] data);
//删除记录
        [DllImport("Reader1000DLL.dll")]
        public static extern int DeleteAllRecord(int hScanner);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_DeleteAllRecord(int hSocket);

//获得读写器ID
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetReaderID(int hScanner, byte[] ReaderID);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetReaderID(int hSocket, byte[] ReaderID);

//==============================网络命令==============================
//设置读写器IP地址
        [DllImport("Reader1000DLL.dll")]
        public static extern int SetReaderNetwork(int hScanner, byte[] IP_Address, int Port, byte[] Mask, byte[] Gateway);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_SetReaderNetwork(int hSocket, byte[] IP_Address, int Port, byte[] Mask, byte[] Gateway);

//获得读写器IP地址
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetReaderNetwork(int hScanner, byte[] IP_Address, ref int Port, byte[] Mask, byte[] Gateway);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetReaderNetwork(int hSocket, byte[] IP_Address, ref int Port, byte[] Mask, byte[] Gateway);

//设置读写器MAC地址
        [DllImport("Reader1000DLL.dll")]
        public static extern int SetReaderMAC(int hScanner, byte[] MAC);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_SetReaderMAC(int hSocket, byte[] MAC);

//获得读写器MAC地址
        [DllImport("Reader1000DLL.dll")]
        public static extern int GetReaderMAC(int hScanner, byte[] MAC);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_GetReaderMAC(int hSocket, byte[] MAC);
#endregion

#region EPCC1G2
        //==============================EPCC1G2数据读写命令==============================
 //识别标签的EPC

        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_ReadLabelID(int hScanner, int mem, int ptr, int len, byte[] mask, byte[] IDBuffer, ref int nCounter, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_ReadLabelID(int hSocket, int mem, int ptr, int len, byte[] mask, byte[] IDBuffer, ref int nCounter);
//读一块数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_ReadWordBlock(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte mem, byte ptr, byte len, byte[] Data, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_ReadWordBlock(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte mem, byte ptr, byte len, byte[] Data, byte[] AccessPassword);

//写一块数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_WriteWordBlock(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte mem, byte ptr, byte len, byte[] Data, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_WriteWordBlock(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte mem, byte ptr, byte len, byte[] Data, byte[] AccessPassword);
//设置读写保护状态
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_SetLock(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte mem, byte Lock, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_SetLock(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte mem, byte Lock, byte[] AccessPassword);
//擦除标签数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_EraseBlock(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte mem, byte ptr, byte len, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_EraseBlock(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte mem, byte ptr, byte len);
//永久休眠标签
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_KillTag(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte[] KillPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_KillTag(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte[] KillPassword);
//写EPC
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_WriteEPC(int hScanner, byte len, byte[] Data, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_WriteEPC(int hSocket, byte len, byte[] Data, byte[] AccessPassword);
//块锁命令
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_BlockLock(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte ptr, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int NetEPC1G2_BlockLock(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte ptr, byte[] AccessPassword);
//EAS状态操作命令
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_ChangeEas(int hScanner, byte EPC_WORD, byte[] IDBuffer, byte State, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_ChangeEas(int hSocket, byte EPC_WORD, byte[] IDBuffer, byte State, byte[] AccessPassword);

//EAS报警命令
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_EasAlarm(int hScanner, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_EasAlarm(int hSocket);

//读保护设置
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_ReadProtect(int hScanner, byte[] AccessPassword, byte EPC_WORD, byte[] IDBuffer, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_ReadProtect(int hSocket, byte[] AccessPassword, byte EPC_WORD, byte[] IDBuffer);

//复位读保护设置
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_RStreadProtect(int hScanner, byte[] AccessPassword, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_RStreadProtect(int hSocket, byte[] AccessPassword);

//侦测标签
        [DllImport("Reader1000DLL.dll")]
        public static extern int EPC1G2_DetectTag(int hScanner, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_EPC1G2_DetectTag(int hSocket);

#endregion

#region ISO6B
        //==============================ISO-6B数据读写命令==============================
//检测标签存在
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_LabelPresent(int hScanner, ref int nCounter, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_LabelPresent(int hSocket, ref int nCounter);

//读取ISO6B标签ID号
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_ReadLabelID(int hScanner, byte[,] IDBuffer, ref int nCounter, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_ReadLabelID(int hSocket, byte[,] IDBuffer, ref int nCounter);

//列出选定标签
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_ListSelectedID(int hScanner, int Cmd, int ptr, byte Mask, byte[] Data, byte[,] IDBuffer, ref int nCounter, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_ListSelectedID(int hSocket, int Cmd, int ptr, byte Mask, byte[] Data, byte[,] IDBuffer, ref int nCounter);

//读一块数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_ReadByteBlock(int hScanner, byte[] IDBuffer, byte ptr, byte len, byte[] Data, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_ReadByteBlock(int hSocket, byte[] IDBuffer, byte ptr, byte len, byte[] Data);

//写一块数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_WriteByteBlock(int hScanner, byte[] IDBuffer, byte ptr, byte len, byte[] Data, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_WriteByteBlock(int hSocket, byte[] IDBuffer, byte ptr, byte len, byte[] Data);

//置写保护状态
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_WriteProtect(int hScanner, byte[] IDBuffer, byte ptr, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_WriteProtect(int hSocket, byte[] IDBuffer, byte ptr);

//读写保护状态
        [DllImport("Reader1000DLL.dll")]
        public static extern int ISO6B_ReadWriteProtect(int hScanner, byte[] IDBuffer, byte ptr, ref byte Protected, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_ISO6B_ReadWriteProtect(int hSocket, byte[] IDBuffer, byte ptr, ref byte Protected);

#endregion

#region TK900
//读取TK900标签ID号
        [DllImport("Reader1000DLL.dll")]
        public static extern int TK900_ReadLabelID(int hScanner, byte[,] IDBuffer, ref int nCounter, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_TK900_ReadLabelID(int hSocket, byte[,] IDBuffer, ref int nCounter);

//读一块数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int TK900_ReadPageBlock(int hScanner, byte[] IDBuffer, byte ptr, byte len, byte[,] Data, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_TK900_ReadPageBlock(int hSocket, byte[] IDBuffer, byte ptr, byte len, byte[,] Data);

//写一块数据
        [DllImport("Reader1000DLL.dll")]
        public static extern int TK900_WritePageBlock(int hScanner, byte[] IDBuffer, byte ptr, byte[] Data, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_TK900_WritePageBlock(int hSocket, byte[] IDBuffer, byte ptr, byte[] Data);

//置写保护状态
        [DllImport("Reader1000DLL.dll")]
        public static extern int TK900_SetProtect(int hScanner, byte[] IDBuffer, byte ptr, byte len, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_TK900_SetProtect(int hSocket, byte[] IDBuffer, byte ptr, byte len);

//读写保护状态
        [DllImport("Reader1000DLL.dll")]
        public static extern int TK900_GetProtect(int hScanner, byte[] IDBuffer, byte[] State, int Address);
        [DllImport("Reader1000DLL.dll")]
        public static extern int Net_TK900_GetProtect(int hScanner, byte[] IDBuffer, byte[] State);

        #endregion

        #region systemAPI
        public delegate void TimerProc(IntPtr hWnder, uint nMsg, int nIDEvent, int dwTime);
            [DllImport("user32.dll")]
            public static extern int SetTimer(int hwnd, int nIDEvent, int uElapse, TimerProc CB);
            [DllImport("user32.dll")]
        public static extern int KillTimer(int hwnd, int nIDEvent);

        [DllImport("kernel32.dll")]
        public static extern bool GetCommState(
         int hFile,
         ref DCB lpDCB
       );

        [DllImport("kernel32.dll")]
        public static extern bool SetCommState(
         int hFile,  // 通信设备句柄 
         ref DCB lpDCB    // 设备控制块 
       );

        [DllImport("kernel32.dll")]
        public static extern bool PurgeComm(
        int hFile,  // 通信设备句柄 
        uint dwFlags
        );


//        [DllImport("kernel32.dll")]
//        public static extern bool Beep(int frequency, int duration);

        [DllImport("user32.dll")]
        public static extern bool MessageBeep(int beepType);


        [StructLayout(LayoutKind.Sequential)]
        public struct DCB
        {
            //taken from c struct in platform sdk  
            public int DCBlength;           // sizeof(DCB)  
            public int BaudRate;            // 指定当前波特率 current baud rate 
            // these are the c struct bit fields, bit twiddle flag to set 
            public int fBinary;          // 指定是否允许二进制模式,在windows95中必须主TRUE binary mode, no EOF check  
            public int fParity;          // 指定是否允许奇偶校验 enable parity checking  
            public int fOutxCtsFlow;      // 指定CTS是否用于检测发送控制，当为TRUE是CTS为OFF，发送将被挂起。 CTS output flow control  
            public int fOutxDsrFlow;      // 指定CTS是否用于检测发送控制 DSR output flow control  
            public int fDtrControl;       // DTR_CONTROL_DISABLE值将DTR置为OFF, DTR_CONTROL_ENABLE值将DTR置为ON, DTR_CONTROL_HANDSHAKE允许DTR"握手" DTR flow control type  
            public int fDsrSensitivity;   // 当该值为TRUE时DSR为OFF时接收的字节被忽略 DSR sensitivity  
            public int fTXContinueOnXoff; // 指定当接收缓冲区已满,并且驱动程序已经发送出XoffChar字符时发送是否停止。TRUE时，在接收缓冲区接收到缓冲区已满的字节XoffLim且驱动程序已经发送出XoffChar字符中止接收字节之后，发送继续进行。　FALSE时，在接收缓冲区接收到代表缓冲区已空的字节XonChar且驱动程序已经发送出恢复发送的XonChar之后，发送继续进行。XOFF continues Tx  
            public int fOutX;          // TRUE时，接收到XoffChar之后便停止发送接收到XonChar之后将重新开始 XON/XOFF out flow control  
            public int fInX;           // TRUE时，接收缓冲区接收到代表缓冲区满的XoffLim之后，XoffChar发送出去接收缓冲区接收到代表缓冲区空的XonLim之后，XonChar发送出去 XON/XOFF in flow control  
            public int fErrorChar;     // 该值为TRUE且fParity为TRUE时，用ErrorChar 成员指定的字符代替奇偶校验错误的接收字符 enable error replacement  
            public int fNull;          // eTRUE时，接收时去掉空（0值）字节 enable null stripping  
            public int fRtsControl;     // RTS flow control 
            /*RTS_CONTROL_DISABLE时,RTS置为OFF 
             RTS_CONTROL_ENABLE时, RTS置为ON 
           RTS_CONTROL_HANDSHAKE时, 
           当接收缓冲区小于半满时RTS为ON 
              当接收缓冲区超过四分之三满时RTS为OFF 
           RTS_CONTROL_TOGGLE时, 
           当接收缓冲区仍有剩余字节时RTS为ON ,否则缺省为OFF*/
            public int fAbortOnError;   // TRUE时,有错误发生时中止读和写操作 abort on error  
            public int fDummy2;        // 未使用 reserved  

            public uint flags;
            public ushort wReserved;          // 未使用,必须为0 not currently used  
            public ushort XonLim;             // 指定在XON字符发送这前接收缓冲区中可允许的最小字节数 transmit XON threshold  
            public ushort XoffLim;            // 指定在XOFF字符发送这前接收缓冲区中可允许的最小字节数 transmit XOFF threshold  
            public byte ByteSize;           // 指定端口当前使用的数据位   number of bits/byte, 4-8  
            public byte Parity;             // 指定端口当前使用的奇偶校验方法,可能为:EVENPARITY,MARKPARITY,NOPARITY,ODDPARITY  0-4=no,odd,even,mark,space  
            public byte StopBits;           // 指定端口当前使用的停止位数,可能为:ONESTOPBIT,ONE5STOPBITS,TWOSTOPBITS  0,1,2 = 1, 1.5, 2  
            public char XonChar;            // 指定用于发送和接收字符XON的值 Tx and Rx XON character  
            public char XoffChar;           // 指定用于发送和接收字符XOFF值 Tx and Rx XOFF character  
            public char ErrorChar;          // 本字符用来代替接收到的奇偶校验发生错误时的值 error replacement character  
            public char EofChar;            // 当没有使用二进制模式时,本字符可用来指示数据的结束 end of input character  
            public char EvtChar;            // 当接收到此字符时,会产生一个事件 received event character  
            public ushort wReserved1;         // 未使用 reserved; do not use  
        }

         #endregion

    }

}