// ConnectReader.cpp : implementation file
//

#include "stdafx.h"
#include "readerdemo.h"
#include "ConnectReader.h"
#include "ReaderDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectReader property page

IMPLEMENT_DYNCREATE(CConnectReader, CPropertyPage)

CConnectReader::CConnectReader() : CPropertyPage(CConnectReader::IDD)
{
	//{{AFX_DATA_INIT(CConnectReader)
	m_Port = 0;
	m_HostPort = 0;
	m_ConnectMode = 0;
	//}}AFX_DATA_INIT
}

CConnectReader::~CConnectReader()
{
}

void CConnectReader::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectReader)
	DDX_Control(pDX, IDC_LIST1, m_IPList);
	DDX_Control(pDX, IDC_IPADDRESS2, m_HostIPAddress);
	DDX_Control(pDX, IDC_IPADDRESS1, m_IPAddress);
	DDX_Control(pDX, IDC_COMBO1, m_SerialPort);
	DDX_Text(pDX, IDC_EDIT1, m_Port);
	DDX_Text(pDX, IDC_EDIT2, m_HostPort);
	DDX_Radio(pDX, IDC_RADIO1, m_ConnectMode);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectReader, CPropertyPage)
	//{{AFX_MSG_MAP(CConnectReader)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_RADIO1, OnRadio1)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio2)
	ON_NOTIFY(NM_CLICK, IDC_LIST1, OnClickList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectReader message handlers

BOOL CConnectReader::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	DWORD dwStyle = m_IPList.SendMessage(LVM_GETEXTENDEDLISTVIEWSTYLE);
	dwStyle |= LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES;
	m_IPList.SendMessage(LVM_SETEXTENDEDLISTVIEWSTYLE, 0, (LPARAM)dwStyle);
	CRect rect;
	m_IPList.GetClientRect(&rect);
	rect.right-=20;
	m_IPList.InsertColumn(0, "No.", LVCFMT_LEFT, int(rect.Width()*2.f/12.f));
	m_IPList.InsertColumn(1, "IP Address", LVCFMT_LEFT, int(rect.Width()*7.f/12.f));
	m_IPList.InsertColumn(2, "port", LVCFMT_LEFT, int(rect.Width()*3.f/12));

	int i,k;
	CString nameList[100],portList[100];
	k=GetSystemPorts(nameList,portList);
	for(i=0;i<k;i++)
	{
		m_SerialPort.AddString(portList[i]);
	}
 
// 	m_SerialPort.AddString("COM1");
//	m_SerialPort.AddString("COM2");
	m_SerialPort.SetCurSel(0);

	Readini(); 

	CString Result="";   
    WSADATA wsaData;   
    char Name[255];   
    hostent* hostinfo;   
    WORD wVersionRequested=MAKEWORD(2,2);   
    if (WSAStartup(wVersionRequested,&wsaData)==0)
	{   
		if (gethostname(Name,sizeof(Name))==0)
		{   
			hostinfo=gethostbyname(Name);   
            if(hostinfo!=NULL)   
				Result=inet_ntoa   (*(struct in_addr *)*hostinfo->h_addr_list);   
        }   
        WSACleanup();         
    }

	m_HostIPAddress.SetWindowText(Result);
	m_HostPort=5000;
	UpdateData(FALSE);

	ConnectMode=m_ConnectMode;

	UpdateStatus();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConnectReader::UpdateStatus()
{
	GetDlgItem(IDC_IPADDRESS1)->EnableWindow(!ifConnectReader && !ConnectMode);
	GetDlgItem(IDC_EDIT1)->EnableWindow(!ifConnectReader && !ConnectMode);
	GetDlgItem(IDC_IPADDRESS2)->EnableWindow(!ifConnectReader && !ConnectMode);
	GetDlgItem(IDC_EDIT2)->EnableWindow(!ifConnectReader && !ConnectMode);
	GetDlgItem(IDC_BUTTON1)->EnableWindow(!ifConnectReader);
	GetDlgItem(IDC_BUTTON2)->EnableWindow(ifConnectReader);
	GetDlgItem(IDC_LIST1)->EnableWindow(!ifConnectReader && !ConnectMode);
	GetDlgItem(IDC_RADIO1)->EnableWindow(!ifConnectReader);
	GetDlgItem(IDC_RADIO2)->EnableWindow(!ifConnectReader);
	GetDlgItem(IDC_COMBO1)->EnableWindow(!ifConnectReader && ConnectMode);
}

void CConnectReader::Readini()
{
	//ȡӦóǰ·
	CString  FilePath;
	FilePath+=".\\IPAddress.ini";

	CString strSection="Number";
	CString strSectionKey="num";
	char inBuf[80];
	GetPrivateProfileString (strSection,strSectionKey, NULL, inBuf, 80, FilePath); 

	int i,num;
	CString str;
	num=atoi(inBuf);
	for(i=0;i<num;i++)
	{
		str="";
		str.Format("%d",i+1);
		m_IPList.InsertItem(i,str);
		strSection="IP"+str;

		strSectionKey="Address";
		GetPrivateProfileString (strSection,strSectionKey, NULL, inBuf, 80, FilePath);
		m_IPList.SetItemText(i,1,inBuf);

		strSectionKey="port";
		GetPrivateProfileString (strSection,strSectionKey, NULL, inBuf, 80, FilePath);
		m_IPList.SetItemText(i,2,inBuf);
	}
}

void CConnectReader::OnButton1() 
{
	UpdateData(TRUE);
	DWORD dwIPAddress;
	CString m_strIPAddress,m_strHostIPAddress;
	m_IPAddress.GetAddress(dwIPAddress);
	m_strIPAddress.Format("%d.%d.%d.%d",
		HIBYTE(HIWORD(dwIPAddress)),
		LOBYTE(HIWORD(dwIPAddress)),
		HIBYTE(LOWORD(dwIPAddress)),
		LOBYTE(LOWORD(dwIPAddress))
		);
	m_HostIPAddress.GetAddress(dwIPAddress);
	m_strHostIPAddress.Format("%d.%d.%d.%d",
		HIBYTE(HIWORD(dwIPAddress)),
		LOBYTE(HIWORD(dwIPAddress)),
		HIBYTE(LOWORD(dwIPAddress)),
		LOBYTE(LOWORD(dwIPAddress))
		);

	apiReturn res;
	char port[32],IPAddr[32],hostIP[32];
	switch(ConnectMode)
	{
	case 0:
		wsprintf(IPAddr, "%s",LPCTSTR(m_strIPAddress));
		wsprintf(hostIP, "%s",LPCTSTR(m_strHostIPAddress));
		res=Net_ConnectScanner(&m_hSocket,IPAddr,m_Port,hostIP,m_HostPort);
		break;
	case 1:
		m_SerialPort.GetLBText(m_SerialPort.GetCurSel(),IPAddr);
		wsprintf(port, "\\\\.\\%s",IPAddr);
		res=ConnectScanner(&m_hScanner,port,0);
		break;
	}
	if (res==_OK)
	{
		Sleep(50);
		ifConnectReader=1;
		NewConnect=1;
		switch(ConnectMode)
		{
		case 0:
			res=Net_GetReaderVersion(m_hSocket,&m_HardVersion,&m_SoftVersion);
			break;
		case 1:
			res=GetReaderVersion(m_hScanner,&m_HardVersion,&m_SoftVersion,0);
			break;
		}
		if (res!=_OK)
		{
			MessageBox("Connect Reader Fail!","Warring",MB_ICONWARNING);
			return;
		}
		UpdateStatus();
		MessageBox("Connect Reader Success!","Notice",MB_ICONINFORMATION);
		
		CReaderDemoDlg * pMainDlg=(CReaderDemoDlg *)pMain;
		pMainDlg->m_Sheet.SetActivePage(1);
	}
	else
	{
		MessageBox("Connect Reader Fail!","Warring",MB_ICONWARNING);
	}

}

void CConnectReader::OnButton2() 
{
	switch(ConnectMode)
	{
	case 0:
		Net_DisconnectScanner();
		break;
	case 1:
		DisconnectScanner(m_hScanner);
		break;
	}
	ifConnectReader=0;
	NewConnect=0;
	m_HardVersion=0;
	m_SoftVersion=0;
	UpdateStatus();
}

void CConnectReader::OnClickList1(NMHDR* pNMHDR, LRESULT* pResult) 
{
	POSITION pos;
	pos=m_IPList.GetFirstSelectedItemPosition();
	if (pos != NULL)
	{
		while (pos)
		{
			int nItemSelected = m_IPList.GetNextSelectedItem(pos);
			m_Port=atoi(m_IPList.GetItemText(nItemSelected,2));
			m_IPAddress.SetWindowText(m_IPList.GetItemText(nItemSelected,1));
	
			UpdateData(FALSE);
		}
	}
	
	*pResult = 0;
}

void CConnectReader::OnRadio1() 
{
	UpdateData(TRUE);	
	ConnectMode=m_ConnectMode;
	UpdateStatus();
}

void CConnectReader::OnRadio2() 
{
	UpdateData(TRUE);	
	ConnectMode=m_ConnectMode;
	UpdateStatus();
}
